/* getc() */

#include <tt.h>

int getc(FILE *f)
{
  int c;
  if (f->flags&3) c = EOF;
  else if (f->i < f->n) c = f->buffer[f->i++];
  else if ((f->n = read(f->handle,f->buffer,f->buffer_size))>0)
  {
    f->i = 1;
    c = f->buffer[0];
  }
  else
  {
    f->i = 0;
    if (f->n<0)
    {
      f->flags |= 2;
      if (f->error!=NULL) {close(f->handle); jump(f->error);}
    }
    else
    {
      f->flags |= 1;
      if (f->end_of_file!=NULL)  {close(f->handle); jump(f->end_of_file);}
    }
    c = EOF;
  }
  return c;
}
