/* allocate_permanent() */

#include <tt.h>

unsigned maximum_permanent = 4096;

void far *allocate_permanent(unsigned n)
{
  static unsigned bytes_in_buffer = 0;
  static char far *buffer;
  char far *b;
  if (n>bytes_in_buffer)
  {
    buffer = allocate(maximum_permanent);
    if (buffer==FAR_NULL)
    {
      bytes_in_buffer = 0;
      return FAR_NULL;
    }
    bytes_in_buffer = maximum_permanent;
    if (n>maximum_permanent) return FAR_NULL;
  }
  b = buffer;
  buffer += n;
  bytes_in_buffer -= n;
  return b;
}
