;  execute_program()

_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

DGROUP  GROUP   _TEXT, _DATA

_DATA   SEGMENT WORD PUBLIC 'DATA'

        EXTRN   _critical_error_flag:WORD

FCB1    DB      32 DUP (?)
FCB2    DB      32 DUP (?)

ENVIRONMENT_SEGMENT     DW      (?)
COMLINE_OFFSET          DW      (?)
COMLINE_SEGMENT         DW      (?)
FCB1_OFFSET             DW      OFFSET DGROUP:FCB1
FCB1_SEGMENT            DW      (?)
FCB2_OFFSET             DW      OFFSET DGROUP:FCB2
FCB2_SEGMENT            DW      (?)

HOLDSP  DW      (?)

_DATA   ENDS

_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:DGROUP

        PUBLIC  _execute_program
        EXTRN   __no_error:NEAR

_execute_program PROC NEAR

        PUSH    BP
        MOV     BP,SP
        PUSH    SI
        PUSH    DI
        MOV     _critical_error_flag,0
        MOV     AX,DS
        MOV     COMLINE_SEGMENT,AX
        MOV     FCB1_SEGMENT,AX
        MOV     FCB2_SEGMENT,AX
        MOV     ES,AX
        MOV     AX,[BP+8]               ; environment
        MOV     ENVIRONMENT_SEGMENT,AX
        MOV     SI,[BP+6]               ; command line
        MOV     COMLINE_OFFSET,SI
        INC     SI
        MOV     DI,OFFSET DGROUP:FCB1
        MOV     AX,2900H
        INT     21H
        MOV     DI,OFFSET DGROUP:FCB2
        MOV     AX,2900H
        INT     21H
        MOV     DX,[BP+4]               ; file specs
        MOV     BX,OFFSET DGROUP:ENVIRONMENT_SEGMENT
        MOV     AX,4B00H
        MOV     WORD PTR HOLDSP,SP
        INT     21H
        MOV     BX,CS
        MOV     DS,BX
        CLI
        MOV     SP,HOLDSP
        MOV     SS,BX
        STI
        POP     DI
        POP     SI
        POP     BP
        JMP     __no_error

_execute_program ENDP

_TEXT   ENDS
        END
