/* fopen_handle() */

#include <tt.h>

FILE *fopen_handle(int handle, boolean write, unsigned buffer_size,
  jump_buffer eof, jump_buffer error)
{
  FILE *f = malloc(sizeof(FILE));
  if (f==NULL) return NULL;
  f->buffer = malloc(buffer_size);
  if (f->buffer == NULL) {free(f); return NULL;}
  f->handle = handle;
  f->i = f->n = 0;
  f->flags = write ? 4 : 0;
  f->buffer_size = buffer_size;
  f->end_of_file = eof;
  f->error = error;
  return f;
}
