/* set_comparison_table */

#include <tt.h>

boolean set_comparison_table(char *rank_string)
{
  register signed char *s = (signed char *) rank_string;
  signed char rank = 1;
  block_fill(0, comparison_table, sizeof(comparison_table));
  while (*s!=0)
  {
    if (*s < '!') return FALSE;
    if (*s == '$')
    {
      unsigned i;
      for (i = 'a'-32; i <= 'z'-32; i++)
      {
        if (comparison_table[i]==0)
          comparison_table[i] = comparison_table[i-('a'-'A')];
        else if (comparison_table[i-('a'-'A')]==0)
          comparison_table[i-('a'-'A')] = comparison_table[i];
        else return FALSE;
      }
      break;
    }
    else
    {
      signed char delta_rank = 0;
      signed char c = *s++;
      signed char cmax = c;
      switch (*s)
      {
        case ',':
          delta_rank = 1;
          /* fall through */
        case '&':
          s++;
          break;
        case '-':
          delta_rank = 1;
          /* fall through */
        case '!':
          if ((cmax = *++s) <= c) return FALSE;
          cmax--;
        case '$': case 0: break;
        default: return FALSE;
      }
      do
      {
        if (comparison_table[c-32] != 0) return FALSE;
        comparison_table[c-32] = rank;
        rank += delta_rank;
      } while (c++ != cmax);
    }
  }
  return TRUE;
}

