; _serial_interrupt()
; June 1, 1989


SERIAL  STRUC

BASE    DW      (?)
BUFFER  DW      (?)
INDEX   DW      (?)
COUNT   DW      (?)
BSIZE   DW      (?)
OVERFLO DW      (?)
IRQ     DW      (?)

SERIAL  ENDS


_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

DGROUP  GROUP   _TEXT


_TEXT   SEGMENT
        ASSUME  CS:DGROUP

        PUBLIC  __serial_interrupt

__serial_interrupt PROC FAR

        PUSH    AX
        PUSH    BX
        PUSH    DX
        PUSH    DI
        PUSH    DS
        MOV     AX,CS
        MOV     DS,AX
        MOV     DX,[SI].BASE
        ADD     DX,2
        IN      AL,DX           ; read interrupt identification
        SUB     DX,2
        IN      AL,DX           ; read input byte
        MOV     DX,[SI].COUNT
        CMP     DX,[SI].BSIZE
        JBE     INSERT
        MOV     [SI].OVERFLO,1
        JMP SHORT EXIT
INSERT: MOV     DI,[SI].INDEX
        MOV     BX,[SI].BUFFER
        MOV     [BX+DI],AL
        INC     DI
        AND     DI,[SI].BSIZE
        MOV     [SI].INDEX,DI
        INC     [SI].COUNT
EXIT:   MOV     AL,20H
        CMP     [SI].IRQ,8
        JB      EXIT2
        OUT     0A0H,AL
EXIT2:  OUT     20H,AL
        POP     DS
        POP     DI
        POP     DX
        POP     BX
        POP     AX
        POP     SI
        IRET

__serial_interrupt ENDP

_TEXT   ENDS
        END
